<?php
/* @(#) $Id: os_lib_agent.php,v 1.2 2006/11/05 15:46:51 dcid Exp $ */

/* Copyright (C) 2006 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */
       


/* Get agent os */
function __os_getagentos($agent_file)
{
    $fp = fopen($agent_file, "r");
    if($fp === FALSE)
    {
        return("No system info available");
    }
    
    $buffer = fgets($fp, 1024);
    $buffer = rtrim($buffer);
    
    fclose($fp);

    return($buffer);
}


function os_getagents($ossec_handle)
{
    $dh = NULL;
    $file = NULL;
    $agent_list = NULL;
    $agent_count = 0;

    /* Checking if agent_dir is set */
    if(!isset($ossec_handle{'agent_dir'})||($ossec_handle{'agent_dir'}==NULL))
    {
        $ossec_handle{'error'} = "Unable to open agent dir: ".
                                  $ossec_handle{'agent_dir'};
        return(NULL);
    }

    $agent_list[$agent_count]{'change_time'} = time();;
    $agent_list[$agent_count]{'name'} = "ossec-server";
    $agent_list[$agent_count]{'ip'} = "127.0.0.1";
    $agent_list[$agent_count]{'os'} = `uname -a`;
    $agent_list[$agent_count]{'connected'} = 1;
    $agent_count++;
    
    /* Getting all agent files */
    if(@$dh = opendir($ossec_handle{'agent_dir'}))
    {
        while(($file = readdir($dh)) !== false)
        {
            $name = "";
            $ip = "";
            $split_error = 0;
            $tmp_file = $file;
            
            if(($file == ".") || ($file == ".."))
            {
                continue;
            }

            /* Splitting the file. We may have multiple "-". */
            while(1)
            {
                @list($_name, $_ip) = split("-", $tmp_file, 2);
                
                /* Nothing more to split */
                if(!isset($_name) || !isset($_ip))
                {
                    break;
                }

                if($name != "")
                {
                    $name = $name."-".$_name;
                }
                else
                {
                    $name = $_name;
                }
                $ip = $_ip;
                $tmp_file = $_ip;
            }

            /* If name or ip is not set, keep going.. */
            if(($name == "") || ($ip == ""))
            {
                continue;
            }

            $fmtime = filemtime($ossec_handle{'agent_dir'}.'/'.$file);
            
            /* If false, file does not exist */
            if($fmtime == FALSE)
            {
                continue;
            }
            
            $agent_list[$agent_count]{'change_time'} = $fmtime;
            $agent_list[$agent_count]{'name'} = $name;
            $agent_list[$agent_count]{'ip'} = $ip;
            $agent_list[$agent_count]{'os'} = 
                        __os_getagentos($ossec_handle{'agent_dir'}.'/'.$file);
            if((time(0) - $fmtime) < $ossec_handle{'notify_time'})
            {
                $agent_list[$agent_count]{'connected'} = 1;
            }
            else
            {
                $agent_list[$agent_count]{'connected'} = 0;
            }
            $agent_count++;
        }
        closedir($dh);
        return($agent_list);
    }

    $ossec_handle{'error'} = "Unable to open agent dir: ".
                             $ossec_handle{'agent_dir'};
    return(NULL);
}


?>
