<?php
/* @(#) $Id: os_lib_handle.php,v 1.3 2007/03/20 02:36:07 dcid Exp $ */

/* Copyright (C) 2006 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */
       

/* os_handle Functions.
 * They always returns NULL on failure.
 */


function os_check_config($ossec_dir, $ossec_max_alerts_per_page,
                         $ossec_search_level, $ossec_search_time,
                         $ossec_refresh_time)
{
    $config_err = "<b id='red'>Configuration error. Missing '%s'.</b><br />";
    
    /* checking each config variable */
    if(!isset($ossec_dir))
    {
        echo sprintf($config_err, '$ossec_dir');
        return(0);
    }

    if(!isset($ossec_max_alerts_per_page))
    {
        echo sprintf($config_err, '$ossec_max_alerts_per_page');
        return(0);
    }

    if(!isset($ossec_search_level))
    {
        echo sprintf($config_err, '$ossec_search_level');
        return(0);
    }

    if(!isset($ossec_search_time))
    {
        echo sprintf($config_err, '$ossec_search_time');
        return(0);
    }

    if(!isset($ossec_refresh_time))
    {
        echo sprintf($config_err, '$ossec_refresh_time');
        return(0);
    }
    
    return(1);
}


/* os_handle_start($dir): Set handle directory.
 * Must always be called first to create the ossec handler.
 */
function os_handle_start($dir)
{
    $ossec_handle{'dir'} = NULL;
    $ossec_handle{'agent_dir'} = NULL;
    $ossec_handle{'name'} = NULL;
    $ossec_handle{'error'} = NULL;


    /* 20 minutes */
    $ossec_handle{'notify_time'} = 1200;

    $dh = NULL;
    if($dh = opendir($dir))
    {
        closedir($dh);
        $ossec_handle{'dir'} = $dir;
        $ossec_handle{'agent_dir'} = $dir."/queue/agent-info";
        
        return($ossec_handle);
    }
    return(NULL);
}


/* EOF */
?>
