<?php
/* @(#) $Id: os_lib_mapping.php,v 1.2 2006/11/05 15:46:51 dcid Exp $ */

/* Copyright (C) 2006 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */
       

/* Get user mapping via FTS */
function os_getusermapping($ossec_handle)
{
    $fp = NULL;
    $file = NULL;
    $mapping_list;

    $fp = fopen($ossec_handle{'dir'}."/queue/fts/fts-queue", "r");
    if($fp === FALSE)
    {
        return(NULL);
    }

    $fts_list = array("sshd", "windows");
    $ign_users = array("SYSTEM");
    
    $preg_fts = "/^(\\S+)\\s+(\\S+)\\s+(\\S+.+)$/";
    
    
    while(!feof($fp))
    {
        $buffer = fgets($fp, 1024);
        $buffer = rtrim($buffer);

        foreach($fts_list as $fts)
        {
            if(strncmp($buffer, $fts, strlen($fts)) == 0)
            {
                if(preg_match($preg_fts, $buffer, $regs) !== FALSE)
                {
                    $ign = 0;
                    foreach($ign_users as $ign)
                    {
                        if($regs[2] == $ign)
                        {
                            $ign = 1;
                        }
                    }
                    if($ign == 0)
                    {
                        $location = NULL;
                        $u_info{'proto'} = $regs[1];
                        $u_info{'user'} = $regs[2];
                        if(strchr($regs[3], ">") === FALSE)
                        {
                            $location = "ossec-server->".$regs[3];
                        }
                        else
                        {
                            $location = $regs[3];
                        }
                        $mapping_list{$location}[] = $u_info;
                    }
                }
                break;
            }
        }
    }

    fclose($fp);
    
    return($mapping_list);
}


?>
