<?php
/* @(#) $Id: main.php,v 1.3 2007/03/20 02:36:08 dcid Exp $ */

/* Copyright (C) 2006 Daniel B. Cid <dcid@ossec.net>
 * All right reserved.
 *
 * This program is a free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public
 * License (version 2) as published by the FSF - Free Software
 * Foundation
 */
       


/* OS PHP init */
if (!function_exists('os_handle_start'))
{
    echo "<b id='red'>You are not allowed direct access.</b><br />\n";
    return(1);
}


/* Starting handle */
$ossec_handle = os_handle_start($ossec_dir);
if($ossec_handle == NULL)
{
    echo "Unable to access ossec directory.\n";
    return(1);
}


/* Getting all agents */
if(($agent_list = os_getagents($ossec_handle)) == NULL)
{
    echo "No agent available.\n";
    return(1);
}


/* Printing current date */
echo '<div class="smaller2"><b>'.date('F dS Y h:i:s A').'</b></div><br />';


/* Getting syscheck information */
$syscheck_list = os_getsyscheck($ossec_handle);

echo '<table width="95%"><tr><td width="45%" valign="top">';


/* Available agents */
echo "<h1>Available&nbsp;agents:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</h1>\n\n";


/* Agent count for java script */
$agent_count = 0;


/* Looping all agents */
foreach ($agent_list as $agent) 
{
    $atitle = "";
    $aid = "";
    $amsg = "";

    /* If agent is connected */
    if($agent{'connected'})
    {
        $atitle = "Agent active";
        $aid = "bluez";
    }
    else
    {
        $atitle = "Agent Inactive";
        $aid ="red";
        $amsg = " - Inactive";
    }

    echo '
        <span id="toggleagt'.$agent_count.'">
        <a  href="#" id="'.$aid.'" title="'.$atitle.'" 
        onclick="ShowSection(\'agt'.$agent_count.'\');return false;">+'.
        $agent{'name'}." (".$agent{'ip'}.')'.$amsg.'</a><br /> 
        </span>

        <div id="contentagt'.$agent_count.'" style="display: none">

        <a  href="#" id="'.$aid.'" title="'.$atitle.'" 
        onclick="HideSection(\'agt'.
        $agent_count.'\');return false;">-'.$agent{'name'}.
        " (".$agent{'ip'}.')'.$amsg.'</a>
        <br />
        <span class="small">
        <div class="smaller">
        &nbsp;&nbsp;<b>Name:</b> '.$agent{'name'}.'<br />
        &nbsp;&nbsp;<b>IP:</b> '.$agent{'ip'}.'<br />
        &nbsp;&nbsp;<b>Last keep alive:</b> '.
        date('Y M d H:i:s', $agent{'change_time'}).'<br />
        &nbsp;&nbsp;<b>OS:</b> '.$agent{'os'}.'<br />
        </div>
        </span>
        </div>
        ';
    echo "\n";
    $agent_count++;
}

echo '</td>';


/* Last modified files */
echo "<td valign='top' width='55%'><h1>Latest modified files: </h1>\n\n";
$syscheck_list = os_getsyscheck($ossec_handle);
if(($syscheck_list == NULL) || ($syscheck_list{'global_list'} == NULL))
{
    echo '<ul class="ulsmall" id="bluez">
        No integrity checking information available.<br />
        Nothing reported as changed.
        </ul>
      ';
}
else
{
   if(isset($syscheck_list{'global_list'}) && 
      isset($syscheck_list{'global_list'}{'files'}))
   {
       $sk_count = 0;
       
       foreach($syscheck_list{'global_list'}{'files'} as $syscheck)
       {
           $sk_count++;
           if($sk_count > ($agent_count +4))
           {
               break;
           }
           
           # Initing file name
           $ffile_name = "";
           $ffile_name2 = "";
           
           if(strlen($syscheck[2]) > 40)
           {
               $ffile_name = substr($syscheck[2], 0, 39)."..";
               $ffile_name2 = substr($syscheck[2], 40, 85);
           }
           else
           {
               $ffile_name = $syscheck[2];
           }
           
           echo '
               <span id="togglesk'.$sk_count.'">
               <a  href="#" id="bluez" title="Expand '.$syscheck[2].'" 
               onclick="ShowSection(\'sk'.$sk_count.'\');return false;">+'.
               $ffile_name.'</a><br /> 
               </span>

               <div id="contentsk'.$sk_count.'" style="display: none">

               <a  href="#" title="Hide '.$syscheck[2].'" 
               onclick="HideSection(\'sk'.
               $sk_count.'\');return false;">-'.$ffile_name.'</a>
               <br />
               <div class="smaller">
               &nbsp;&nbsp;<b>File:</b> '.$ffile_name.'<br />';
               if($ffile_name2 != "")
               {
                   echo "&nbsp;&nbsp;&nbsp;&nbsp;".$ffile_name2.'<br />';
               }
               echo '
               &nbsp;&nbsp;<b>Agent:</b> '.$syscheck[1].'<br />
               &nbsp;&nbsp;<b>Modification time:</b> '.
               date('Y M d H:i:s', $syscheck[0]).'<br />
               </div>

               </div>
               ';
       }
   }
}


echo '</td></tr></table>
';
echo "<br /> <br />\n";


/* Getting last alerts */
$alert_list = os_getalerts($ossec_handle, 0, 0, 30);
if($alert_list == NULL)
{
    echo "<b id='red'>Unable to retrieve alerts. </b><br />\n";
}
else
{
    echo "<h1>Latest events</h1>\n";
    $evt_count = sizeof($alert_list) -1;

    /* Alerts table */
    echo "<table width=100%>\n";
    
    while($evt_count >= 0)
    {
        $alert = $alert_list[$evt_count];
        $al_date = date('Y M d H:i:s', $alert{'time'});
        echo "<tr class=alert><td><font class=alerts><b>".$al_date.
             '</b> Rule Id: <a href="/wiki/rules/'.$alert{'id'}.
             '">'.$alert{'id'}.'</a>'." level: ".$alert{'level'}.
             "<br /> <b>Location:</b> ".$alert{'location'}."<br />\n".
             '<b>'.$alert{'description'}.
             '</b></font></td></tr><tr class=msg><td>'.
             '<ul class="messagesmall">';
            
        foreach($alert{'msg'} as $alert_msg)
        {     
            if($alert_msg == NULL)
                break;

            echo $alert_msg."<br />\n";     
        }

        echo '</ul></td></tr>'."\n";
        $evt_count--;
    }
    
    echo "</table>\n";
}

?>
